<< problem 37 - Truncatable primes | Integer right triangles - problem 39 >> |
Problem 38: Pandigital multiples
(see projecteuler.net/problem=38)
Take the number 192 and multiply it by each of 1, 2, and 3:
192 * 1 = 192
192 * 2 = 384
192 * 3 = 576
By concatenating each product we get the 1 to 9 pandigital, 192384576. We will call 192384576 the concatenated product of 192 and (1,2,3)
The same can be achieved by starting with 9 and multiplying by 1, 2, 3, 4, and 5, giving the pandigital, 918273645, which is the concatenated product of 9 and (1,2,3,4,5).
What is the largest 1 to 9 pandigital 9-digit number that can be formed as the concatenated product of an integer with (1,2, ... , n) where n > 1?
My Algorithm
A bitmask tracks whether a number is pandigital (or not): if the n-th bit of bitsUsed
is 1 then n is a digit of pandigital
.
A truly pandigital number has a bitmask of bitsAll = (1 << 9) | (1 << 8) | ... | (1 << 2) | (1 << 1)
.
According to the problem statement, a digit must not be zero. That means the lowest bit is always 0:
bitsAll_9=1022 (and bitsAll_8=510 for alternate Hackerrank input).
My program process all numbers i
from 2 to maxFactor
and multiplies them with 1, 2, ... until the concatenated result's bitsUsed == bitsAll
.
Each product = i * multiplier
(where multiplier = 1, 2, ...
) is split into its digits and each digit added to the bitmask bitsUsed
.
When a collision occurs (that digit was already used before), then bitsUsed
is set to an invalid value and the next number i
can be processed.
Modifications by HackerRank
The result may have either 8 or 9 digits and there is an upper limit for the start value.
Note
maxFactor
cannot exceed 10000 because then i*1
+i*2
will have more than 9 digits.
A few things are probably much easier when converting all numbers to std::string
- at the cost of speed.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "200 9" | ./38
Output:
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++ and can be compiled with G++, Clang++, Visual C++. You can download it, too.
The code contains #ifdef
s to switch between the original problem and the Hackerrank version.
Enable #ifdef ORIGINAL
to produce the result for the original problem (default setting for most problems).
#include <iostream>
int main()
{
unsigned int maxFactor, maxDigit; // 10000 and 9 for the original problem
std::cin >> maxFactor >> maxDigit;
// bitmask if all digits are used
unsigned int bitsAll = 0;
for (unsigned int i = 1; i <= maxDigit; i++)
bitsAll |= 1 << i;
#define ORIGINAL
#ifdef ORIGINAL
// largest pandigital number found so far
unsigned int largest = 0;
#endif
// try all numbers
for (unsigned int i = 2; i <= maxFactor; i++)
{
// the whole pandigital number
unsigned int pandigital = 0;
// multiply i by 1,2,3,...
unsigned int multiplier = 1;
// bitmask of used digits (nth bit is set if pandigital contains digit n)
unsigned int bitsUsed = 0;
while (bitsUsed < bitsAll)
{
// next step
unsigned int product = i * multiplier;
// extract right-most digit
while (product > 0)
{
// extract right-most digit
unsigned int digit = product % 10;
// remove it
product /= 10;
// make room to add i*multiplier lateron
pandigital *= 10;
// remember all digits we used
unsigned int bitMask = 1 << digit;
// we already had this digit ?
if (digit == 0 || (bitsUsed & bitMask) != 0)
{
bitsUsed = bitsAll + 1; // set to an invalid value
break;
}
// mark current digit as "used"
bitsUsed |= bitMask;
}
// keep going in the sequence
pandigital += i * multiplier;
multiplier++;
}
// enough digits generated ?
if (bitsUsed == bitsAll)
{
#ifdef ORIGINAL
if (largest < pandigital)
largest = pandigital;
#else
std::cout << i << std::endl;
#endif
}
}
#ifdef ORIGINAL
std::cout << largest << std::endl;
#endif
return 0;
}
This solution contains 15 empty lines, 16 comments and 9 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in less than 0.01 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
February 25, 2017 submitted solution
April 12, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler038
My code solves 6 out of 6 test cases (score: 100%)
Difficulty
Project Euler ranks this problem at 5% (out of 100%).
Hackerrank describes this problem as easy.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Links
projecteuler.net/thread=38 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
C# www.mathblog.dk/project-euler-38-pandigital-multiplying-fixed-number/ (written by Kristian Edlund)
C github.com/eagletmt/project-euler-c/blob/master/30-39/problem38.c (written by eagletmt)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p038.java (written by Nayuki)
Javascript github.com/dsernst/ProjectEuler/blob/master/38 Pandigital multiples.js (written by David Ernst)
Go github.com/frrad/project-euler/blob/master/golang/Problem038.go (written by Frederick Robinson)
Mathematica github.com/nayuki/Project-Euler-solutions/blob/master/mathematica/p038.mathematica (written by Nayuki)
Haskell github.com/nayuki/Project-Euler-solutions/blob/master/haskell/p038.hs (written by Nayuki)
Scala github.com/samskivert/euler-scala/blob/master/Euler038.scala (written by Michael Bayne)
Perl github.com/gustafe/projecteuler/blob/master/038-Pandigital-multiples.pl (written by Gustaf Erikson)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 37 - Truncatable primes | Integer right triangles - problem 39 >> |